configVersion: 1
project: questions-backend
deploy:
  helmRelease: "[[ project ]]-[[ env ]]"
---
image: backend
from: "registry.example.com/infra/php-fpm/backend:v6"
docker:
  WORKDIR: /app
  EXPOSE:
  - '80'
ansible:
  install:
  - name: "Composer Validate"
    composer:
      command: validate
      arguments: --no-check-all
      working_dir: /app
    environment:
      COMPOSER_HOME: /app/.composer
    become: yes
    become_user: app
    ignore_errors: yes
  - name: "Composer install"
    composer:
      command: install
      arguments: --no-dev
      prefer_dist: yes
      working_dir: /app
    environment:
      COMPOSER_HOME: /app/.composer
    become: yes
    become_user: app
  setup:
  - name: "Composer Dump Autoload"
    composer:
      command: dump-autoload
      arguments: --classmap-authoritative
      working_dir: /app
    environment:
      COMPOSER_HOME: /app/.composer
    become: yes
    become_user: app
  - name: "Setup /etc/php/7.2/fpm/php-fpm.conf"
    copy:
      content: |
{{ .Files.Get ".werf/php-fpm.conf" | indent 8 }}
      dest: /etc/php/7.2/fpm/php-fpm.conf
  - name: "Setup wait-rabbitmq.php"
    copy:
      content: |
{{ .Files.Get ".werf/wait-rabbitmq.php" | indent 8 }}
      dest: /app/wait-rabbitmq.php
git:
- add: /
  to: /app
  owner: app
  group: app
  excludePaths:
  - .werf
  - .helm
  - .gitlab-ci.yml
  stageDependencies:
    install:
    - composer.lock
    setup:
    - '*'
---
image: frontend
from: "registry.example.com/infra/nginx-upstream-limit:v1"
docker:
  WORKDIR: /app
  EXPOSE:
  - '80'
import:
- artifact: api-specification
  add: /app/public/spec
  after: setup
git:
- add: /
  to: /app
  excludePaths:
  - .werf
  - .helm
---
artifact: api-specification
from: registry.example.com/infra/api-spec-builder/app:v3
ansible:
  install:
  - name: install node modules
    command: npm i
    args:
      chdir: /app
  setup:
  - name: Check that specker.yml exists
    stat:
      path: /app/specker.yml
    register: stat_result
  - name: build specification
    command: npx specker build
    args:
      chdir: /app
    when: stat_result.stat.exists == True
  - name: Create empty spec dir
    file:
      path: /app/public/spec
      state: directory
    when: stat_result.stat.exists == False
git:
- add: /
  to: /app
  excludePaths:
  - .werf
  - .helm
  stageDependencies:
    install:
    - package.json
    - package-lock.json
    setup:
    - spec
    - specker.yml
